#include "config.h"

// global read, save configurations
RRSettings loadConfig() {
    RRSettings settings;

    KConfigGroup cfg = KSharedConfig::openConfig("recollrunnerrc")->group( "recollrunner" );

    settings.m_queryType =      (eQUERY) cfg.readEntry( CONFIGQUERY, DEFAULTQUERY );
    settings.m_bFilenamesOnly = cfg.readEntry( CONFIGFILENAMES, DEFAULTFILENAMES );
    settings.m_bRestrictHits =  cfg.readEntry( CONFIGRESTRICTFILES, DEFAULTRESTRICTFILES );
    settings.m_nMaxHits =       cfg.readEntry( CONFIGMAXFILES, DEFAULTMAXFILES );
    settings.m_bRestrictTypes = cfg.readEntry( CONFIGRESTRICTTYPES, DEFAULTRESTRICTTYPES );
    settings.m_fileTypes =      cfg.readEntry( CONFIGTYPES, DEFAULTTYPES );
    settings.m_bRestrictPatterns = cfg.readEntry( CONFIGRESTRICTPATTERNS, DEFAULTRESTRICTPATTERNS );
    settings.m_filePatterns =   cfg.readEntry( CONFIGPATTERNS, DEFAULTPATTERNS );
    settings.m_bAllPatterns =   cfg.readEntry( CONFIGALLPATTERNS, DEFAULTALLPATTERNS );
    settings.m_bHiddenFiles =   cfg.readEntry( CONFIGHIDDEN, DEFAULTHIDDEN );
    settings.m_bNonFiles =      cfg.readEntry( CONFIGNONFILES, DEFAULTNONFILES );
    settings.m_bTag =           cfg.readEntry( CONFIGTAG, DEFAULTTAG );
    settings.m_bRunRecoll =     cfg.readEntry( CONFIGRUNRECOLL, DEFAULTRUNRECOLL );
    settings.m_bRunKIO =        cfg.readEntry( CONFIGRUNKIO, DEFAULTRUNKIO );
    settings.m_bRestrictRank =  cfg.readEntry( CONFIGRESTRICTRANK, DEFAULTRESTRICTRANK );
    settings.m_nMinRank =       cfg.readEntry( CONFIGMINRANK, DEFAULTMINRANK );
    settings.m_sortType =      (eSORT) cfg.readEntry( CONFIGSORT, DEFAULTSORT );
    settings.m_bNoArchives =    cfg.readEntry( CONFIGNOARCHIVES, DEFAULTNOARCHIVES );
    settings.m_bWantPrefix =    cfg.readEntry( CONFIGWANTPREFIX, DEFAULTWANTPREFIX );
    settings.m_thePrefix =      cfg.readEntry( CONFIGTHEPREFIX, DEFAULTTHEPREFIX );
    settings.m_runType =        (eRUN) cfg.readEntry( CONFIGRUNTYPE, DEFAULTRUNTYPE );
    return settings;
}

void saveConfig( const RRSettings& settings ) {
    KConfigGroup cfg = KSharedConfig::openConfig("recollrunnerrc")->group( "recollrunner" );

    cfg.writeEntry( CONFIGQUERY, (int) settings.m_queryType );
    cfg.writeEntry( CONFIGFILENAMES, settings.m_bFilenamesOnly );
    cfg.writeEntry( CONFIGRESTRICTFILES, settings.m_bRestrictHits );
    cfg.writeEntry( CONFIGMAXFILES, settings.m_nMaxHits );
    cfg.writeEntry( CONFIGRESTRICTTYPES, settings.m_bRestrictTypes );
    cfg.writeEntry( CONFIGTYPES, settings.m_fileTypes );
    cfg.writeEntry( CONFIGRESTRICTPATTERNS, settings.m_bRestrictPatterns );
    cfg.writeEntry( CONFIGALLPATTERNS, settings.m_bAllPatterns );
    cfg.writeEntry( CONFIGPATTERNS, settings.m_filePatterns );
    cfg.writeEntry( CONFIGHIDDEN, settings.m_bHiddenFiles );
    cfg.writeEntry( CONFIGNONFILES, settings.m_bNonFiles );
    cfg.writeEntry( CONFIGTAG, settings.m_bTag );
    cfg.writeEntry( CONFIGRUNRECOLL, settings.m_bRunRecoll );
    cfg.writeEntry( CONFIGRUNKIO, settings.m_bRunKIO );
    cfg.writeEntry( CONFIGRESTRICTRANK, settings.m_bRestrictRank );
    cfg.writeEntry( CONFIGMINRANK, settings.m_nMinRank );
    cfg.writeEntry( CONFIGSORT, (int) settings.m_sortType );
    cfg.writeEntry( CONFIGNOARCHIVES, settings.m_bNoArchives );
    cfg.writeEntry( CONFIGWANTPREFIX, settings.m_bWantPrefix );
    cfg.writeEntry( CONFIGTHEPREFIX, settings.m_thePrefix );
    cfg.writeEntry( CONFIGRUNTYPE, (int) settings.m_runType );
}

