/* 
 * File:   config.h
 * Author: david
 *
 * Created on August 5, 2010, 1:26 PM
 */

#ifndef CONFIG_H
#define	CONFIG_H

#include <KCModule>
#include <KConfigGroup>
#include <KSharedConfig>

typedef enum { QUERY, AND, OR } eQUERY;
typedef enum { RANK, NAME, MIMETYPE, DATE } eSORT;
typedef enum { OPENFILE, VIEWER } eRUN;

const QString CONFIGQUERY =     "QueryType";
const QString CONFIGFILENAMES = "QueryFilenames";
const QString CONFIGRESTRICTFILES = "RestrictFiles";
const QString CONFIGMAXFILES =  "MaxFiles";
const QString CONFIGRESTRICTTYPES = "RestrictTypes";
const QString CONFIGTYPES =     "FileTypes";
const QString CONFIGRESTRICTPATTERNS = "RestrictPattern";
const QString CONFIGPATTERNS =  "FilePatterns";
const QString CONFIGALLPATTERNS = "AllFilePatterns";
const QString CONFIGHIDDEN =    "HiddenFiles";
const QString CONFIGNONFILES =  "InvalidFiles";
const QString CONFIGTAG =       "TagAsRecoll";
const QString CONFIGRUNRECOLL = "RunRecoll";
const QString CONFIGRUNKIO =    "RunKIO";
const QString CONFIGRESTRICTRANK = "RestrictRank";
const QString CONFIGMINRANK =   "MinRank";
const QString CONFIGSORT =      "SortType";
const QString CONFIGNOARCHIVES = "NoArchives";
const QString CONFIGWANTPREFIX = "WantPrefix";
const QString CONFIGTHEPREFIX =  "ThePrefix";
const QString CONFIGRUNTYPE =   "RunOption";

// defaults
const int DEFAULTQUERY =        0;
const bool DEFAULTFILENAMES =   false;
const bool DEFAULTRESTRICTFILES = false;
const int DEFAULTMAXFILES =    10;
const bool DEFAULTRESTRICTTYPES = false;
const QString DEFAULTTYPES =  QString();
const bool DEFAULTRESTRICTPATTERNS = false;
const QString DEFAULTPATTERNS = QString();
const bool DEFAULTALLPATTERNS = false;
const bool DEFAULTHIDDEN =      false;
const bool DEFAULTNONFILES =    false;
const bool DEFAULTTAG =         false;
const bool DEFAULTRUNRECOLL =   false;
const bool DEFAULTRUNKIO =      false;
const bool DEFAULTRESTRICTRANK = false;
const int DEFAULTMINRANK =      0;
const int DEFAULTSORT =         0;
const bool DEFAULTNOARCHIVES =  false;
const bool DEFAULTWANTPREFIX =  false;
const QString DEFAULTTHEPREFIX = "recoll:";
const int DEFAULTRUNTYPE =      0;

struct RRSettings {
    eQUERY m_queryType;
    eSORT m_sortType;
    eRUN m_runType;
    bool m_bFilenamesOnly;
    bool m_bRestrictHits;
    bool m_bHiddenFiles;
    bool m_bNonFiles;
    bool m_bTag;
    bool m_bRunRecoll;
    bool m_bRunKIO;
    bool m_bRestrictTypes;
    bool m_bRestrictPatterns;
    bool m_bAllPatterns;
    bool m_bRestrictRank;
    bool m_bNoArchives;
    bool m_bWantPrefix;
    int m_nMaxHits;
    int m_nMinRank;
    QString m_fileTypes;
    QString m_filePatterns;
    QString m_thePrefix;
};

// stuff needs be global!

RRSettings loadConfig();
void saveConfig(const RRSettings &settings);
void saveVersion(QString key, int version);


#endif	/* CONFIG_H */

