/* 
 * File:   recollViewer.h
 * Author: david
 *
 * Created on November 16, 2011, 10:36 AM
 */

#ifndef _RECOLLVIEWER_H
#define	_RECOLLVIEWER_H

#include "plasma/runnercontext.h"
#include "plasma/querymatch.h"
#include "ui_recollViewer.h"
#include "config.h"
#include "recollparser.h"
#include <QListWidget>
#include <QListWidgetItem>
#include <QCloseEvent>

class myQListWidget : public QListWidget {
    Q_OBJECT
    
public:
    myQListWidget() {}
    // expose this one
    //QModelIndex indexFromItem(QListWidgetItem* item ) { return QListWidget::indexFromItem( item ); }

Q_SIGNALS:
    void closing();
    void research();

private slots:
    void closeEvent(QCloseEvent* event) {
        emit closing();    // do this for convenience
        event->accept();
    } 
};

class recollViewparser : public recollparser {
public:
    recollViewparser( Plasma::QueryMatch* match );
    recollViewparser();         // generate null record
    ~recollViewparser() { }
    
    QString viewTitle() { return m_viewTitle; }
    QString viewPath()  { return m_viewPath; }

private:
    QString m_viewPath;
    QString m_viewTitle;
};

class recollViewer : public QDialog {
    Q_OBJECT

public:
    recollViewer();
    void runView(const Plasma::RunnerContext& context,
                const Plasma::QueryMatch& match, RRSettings* options );
    
    void show();
    void registerUserQuery( QString query );
    ~recollViewer() {}

    class annotator {
    public:
        annotator();
        ~annotator() { }

        QString annotate( QString orig, QStringList keywords );
        QString annotate( QString orig, QString keyword );

    private:
        QStringList m_pretags;
        QStringList m_preuntags;
    };

private slots:
    void tonext();
    void toprev();
    void toItem( int item );
    void toItem();
    void stuffItem();
    void runIt();
    void closeEvent(QCloseEvent *event);
    void closingList();
    void requestResearch();
    bool isQueryField( QString, int );
    bool isSkipField( QRegExp, int );
    void clear();

private:
    void stuffList( Plasma::QueryMatch );
    void stuffView();
    void stuffView( recollViewparser& );
    void stuffNullView();

    Ui::recollViewer widget;

    RRSettings* m_options;

    Plasma::QueryMatch* m_thisMatch;
    QList<Plasma::QueryMatch> m_matches;
    int m_nIndex;
    int m_nMatches;

    QString m_path;
    QString m_query;
    QStringList m_ids;
    QStringList m_keywords;
    QStringList m_titlekeywords;

    annotator annot;

    myQListWidget* m_klistSelections;
    bool m_bListChecked;
    bool m_bReopened;
    QRect m_saveGeometry;
    
Q_SIGNALS:
    void research( QString );
};

#endif	/* _RECOLLVIEWER_H */

