/* 
 * File:   recollworker.h
 * Author: david
 *
 * Created on July 29, 2010, 12:28 PM
 */

#ifndef RECOLLWORKER_H
#define	RECOLLWORKER_H

#include <plasma/abstractrunner.h>
#include <plasma/runnercontext.h>
#include <plasma/querymatch.h>

#include <KIcon>
#include <KMimeType>
#include <QProcess>
#include <QFile>
#include <QFileInfo>

#include "config.h"

const float RELEV_EXEC = 0.9;
const float RELEV_DIRECTORY = 0.8;
const float RELEV_FILE = 0.3;
const float RELEV_NONFILE = 0.2;

static QHash<QString, KIcon> iconCache;
    
class RecollAsyncWorker : public QProcess {
    Q_OBJECT

public:
    RecollAsyncWorker(  Plasma::AbstractRunner* runner,
            Plasma::RunnerContext& context, QIcon icon );
    void setOptions( RRSettings* options );
    void startWorker( QString& cmd, QStringList& args, QStringList& abbrev );
    //~RecollAsyncWorker();

public slots:
    void processRecollOutput();
    void postProcess(); // might need to do this first in future :-)
    void echoCmd( QString cmd, QStringList args );  // for debugging
    void echoStr( QString str );

protected:
    bool matchAnyType( QString& mime );
    bool matchAnyPattern( const QFileInfo& finfo );
    bool matchAllPattern( const QFileInfo& finfo );
    bool matchOneType( QString& mime, QString& pattern );
    bool matchOnePattern( const QFileInfo& finfo, QString& Pattern );

    Plasma::AbstractRunner* m_runner;
    Plasma::RunnerContext m_context;

    QString m_term;
    QStringList m_recollArgs;
    QStringList m_fileTypes;
    QStringList m_filePatterns;
    
    QIcon m_icon;
    RRSettings* m_options;

    int m_nHits;
};


#endif	/* RECOLLWORKER_H */

